﻿using System;
using System.ServiceModel;
using DistributedGA.Core.Domain;
using DistributedGA.Core.Interface;

namespace DistributedGA.Core.Implementation
{
    public class WcfMessageSender : IMessageSender
    {
        private PeerInfo myself;

        public void Init(PeerInfo source)
        {
            myself = source;
        }

        public void SendData(PeerInfo destination, byte[][] data)
        {
            var client = CreateServerClient(destination.IpAddress, destination.Port);
            client.SendData(myself, data); //maybe timout exception...
        }

        private IMessageContract CreateServerClient(string ip, int port)
        {
            var serviceUrl = "DistributedGA.svc";
            var baseUri = new Uri(string.Concat("net.tcp://", ip, ":", port, "/DistributedGA"));
            var serviceUri = new Uri(baseUri, serviceUrl);

            var binding = new NetTcpBinding();
            var endpoint = new EndpointAddress(serviceUri);
            var myChannelFactory = new ChannelFactory<IMessageContract>(binding, endpoint);

            IMessageContract client = null;
            client = myChannelFactory.CreateChannel();
            return client;
        }

    }
}
